"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = __importDefault(require("./"));
const status_1 = __importDefault(require("../status"));
const helpers_1 = require("./helpers");
const value_checker_1 = require("../value_checker");
class SnippetsFormatter extends _1.default {
    constructor(options) {
        super(options);
        options.eventBroadcaster.on('envelope', (envelope) => {
            if (value_checker_1.doesHaveValue(envelope.testRunFinished)) {
                this.logSnippets();
            }
        });
    }
    logSnippets() {
        const snippets = [];
        this.eventDataCollector.getTestCaseAttempts().map((testCaseAttempt) => {
            const parsed = helpers_1.parseTestCaseAttempt({
                cwd: this.cwd,
                snippetBuilder: this.snippetBuilder,
                supportCodeLibrary: this.supportCodeLibrary,
                testCaseAttempt,
            });
            parsed.testSteps.forEach((testStep) => {
                if (testStep.result.status === status_1.default.UNDEFINED) {
                    snippets.push(testStep.snippet);
                }
            });
        });
        this.log(snippets.join('\n\n'));
    }
}
exports.default = SnippetsFormatter;
//# sourceMappingURL=snippets_formatter.js.map