import { messages } from '@cucumber/messages';
import { IRuntimeOptions } from '../index';
export interface IWorkerCommand {
    initialize?: IWorkerCommandInitialize;
    run?: IWorkerCommandRun;
    finalize?: boolean;
}
export interface IWorkerCommandInitialize {
    filterStacktraces: boolean;
    supportCodePaths: string[];
    supportCodeRequiredModules: string[];
    options: IRuntimeOptions;
}
export interface IWorkerCommandRun {
    retries: number;
    skip: boolean;
    elapsed: number;
    pickle: messages.IPickle;
    gherkinDocument: messages.IGherkinDocument;
}
export interface ICoordinatorReport {
    jsonEnvelope?: string;
    ready?: boolean;
    supportCodeIds?: ICoordinatorReportSupportCodeIds;
}
export interface ICoordinatorReportSupportCodeIds {
    stepDefinitionIds: string[];
    beforeTestCaseHookDefinitionIds: string[];
    afterTestCaseHookDefinitionIds: string[];
}
