import { IdGenerator, messages } from '@cucumber/messages';
import TestCaseHookDefinition from '../models/test_case_hook_definition';
import TestStepHookDefinition from '../models/test_step_hook_definition';
import TestRunHookDefinition from '../models/test_run_hook_definition';
import StepDefinition from '../models/step_definition';
import { DefineStepPattern, IDefineStepOptions, IDefineSupportCodeMethods, IDefineTestCaseHookOptions, IDefineTestStepHookOptions, IDefineTestRunHookOptions, IParameterTypeDefinition, ISupportCodeLibrary, TestCaseHookFunction, TestStepHookFunction } from './types';
interface ITestCaseHookDefinitionConfig {
    code: any;
    line: number;
    options: any;
    uri: string;
}
interface ITestStepHookDefinitionConfig {
    code: any;
    line: number;
    options: any;
    uri: string;
}
interface ITestRunHookDefinitionConfig {
    code: any;
    line: number;
    options: any;
    uri: string;
}
export declare const builtinParameterTypes: string[];
export declare class SupportCodeLibraryBuilder {
    readonly methods: IDefineSupportCodeMethods;
    private afterTestCaseHookDefinitionConfigs;
    private afterTestRunHookDefinitionConfigs;
    private afterTestStepHookDefinitionConfigs;
    private beforeTestCaseHookDefinitionConfigs;
    private beforeTestRunHookDefinitionConfigs;
    private beforeTestStepHookDefinitionConfigs;
    private cwd;
    private defaultTimeout;
    private definitionFunctionWrapper;
    private newId;
    private parameterTypeRegistry;
    private stepDefinitionConfigs;
    private World;
    constructor();
    defineParameterType(options: IParameterTypeDefinition<any>): void;
    defineStep(pattern: DefineStepPattern, options: IDefineStepOptions | Function, code?: Function): void;
    defineTestCaseHook(getCollection: () => ITestCaseHookDefinitionConfig[]): (options: string | IDefineTestCaseHookOptions | TestCaseHookFunction, code?: TestCaseHookFunction) => void;
    defineTestStepHook(getCollection: () => ITestStepHookDefinitionConfig[]): (options: string | IDefineTestStepHookOptions | TestStepHookFunction, code?: TestStepHookFunction) => void;
    defineTestRunHook(getCollection: () => ITestRunHookDefinitionConfig[]): (options: IDefineTestRunHookOptions | Function, code?: Function) => void;
    wrapCode({ code, wrapperOptions, }: {
        code: Function;
        wrapperOptions: any;
    }): Function;
    buildTestCaseHookDefinitions(configs: ITestCaseHookDefinitionConfig[]): TestCaseHookDefinition[];
    buildTestStepHookDefinitions(configs: ITestStepHookDefinitionConfig[]): TestStepHookDefinition[];
    buildTestRunHookDefinitions(configs: ITestRunHookDefinitionConfig[]): TestRunHookDefinition[];
    buildStepDefinitions(): {
        stepDefinitions: StepDefinition[];
        undefinedParameterTypes: messages.IUndefinedParameterType[];
    };
    finalize(): ISupportCodeLibrary;
    reset(cwd: string, newId: IdGenerator.NewId): void;
}
declare const _default: SupportCodeLibraryBuilder;
export default _default;
