"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var messages_1 = require("@cucumber/messages");
var stream_1 = require("stream");
var src_1 = require("../src");
var fs_1 = __importDefault(require("fs"));
var glob_1 = __importDefault(require("glob"));
var util_1 = require("util");
var asyncPipeline = util_1.promisify(stream_1.pipeline);
describe('Walking with messages', function () {
    var e_1, _a;
    var localMessageFiles = glob_1.default.sync(__dirname + "/messages/**/*.ndjson");
    var tckMessageFiles = glob_1.default.sync(__dirname + "/../../../compatibility-kit/javascript/features/**/*.ndjson");
    var messageFiles = [].concat(localMessageFiles, tckMessageFiles);
    var _loop_1 = function (messageFile) {
        it("can walk through GherkinDocuments in " + messageFile, function () { return __awaiter(void 0, void 0, void 0, function () {
            var messageStream;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        messageStream = new messages_1.NdjsonToMessageStream(messages_1.messages.Envelope.fromObject.bind(messages_1.messages.Envelope));
                        return [4 /*yield*/, asyncPipeline(fs_1.default.createReadStream(messageFile, 'utf-8'), messageStream, new stream_1.Writable({
                                objectMode: true,
                                write: function (envelope, _encoding, callback) {
                                    try {
                                        if (envelope.gherkinDocument) {
                                            var walker = new src_1.GherkinDocumentWalker();
                                            walker.walkGherkinDocument(envelope.gherkinDocument);
                                        }
                                        callback();
                                    }
                                    catch (error) {
                                        error.message += "\n" + envelope.gherkinDocument.uri + "\n";
                                        callback(error);
                                    }
                                },
                            }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }).timeout(30000);
    };
    try {
        for (var messageFiles_1 = __values(messageFiles), messageFiles_1_1 = messageFiles_1.next(); !messageFiles_1_1.done; messageFiles_1_1 = messageFiles_1.next()) {
            var messageFile = messageFiles_1_1.value;
            _loop_1(messageFile);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (messageFiles_1_1 && !messageFiles_1_1.done && (_a = messageFiles_1.return)) _a.call(messageFiles_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
});
//# sourceMappingURL=messageTest.js.map