"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var EnvelopesQueryContext_1 = __importDefault(require("../../EnvelopesQueryContext"));
var CICommitLink_1 = __importDefault(require("./CICommitLink"));
var getDurationMillis_1 = __importDefault(require("../../getDurationMillis"));
var Duration_1 = __importDefault(require("./Duration"));
var Product = function (_a) {
    var name = _a.name, product = _a.product;
    var value = [product.name, product.version]
        .filter(function (v) { return v !== '' && v !== undefined && v !== null; })
        .join(' - ');
    return (react_1.default.createElement("tr", null,
        react_1.default.createElement("th", null, name),
        react_1.default.createElement("td", null, value)));
};
function findTestRunStarted(envelopesQuery) {
    var testRunStarted = envelopesQuery.find(function (envelope) { return envelope.testRunStarted !== null; });
    return testRunStarted ? testRunStarted.testRunStarted : undefined;
}
function findTestRunFinished(envelopesQuery) {
    var testRunFinished = envelopesQuery.find(function (envelope) { return envelope.testRunFinished !== null; });
    return testRunFinished ? testRunFinished.testRunFinished : undefined;
}
var ExecutionSummary = function (_a) {
    var meta = _a.meta;
    var envelopesQuery = react_1.default.useContext(EnvelopesQueryContext_1.default);
    var testRunStarted = findTestRunStarted(envelopesQuery);
    var testRunFinished = findTestRunFinished(envelopesQuery);
    var millisDuration = getDurationMillis_1.default(testRunStarted, testRunFinished);
    return (react_1.default.createElement("div", { className: "cucumber-execution-data" },
        react_1.default.createElement("table", null,
            react_1.default.createElement("tbody", null,
                millisDuration && (react_1.default.createElement("tr", null,
                    react_1.default.createElement("th", null, "Duration"),
                    react_1.default.createElement("td", null,
                        react_1.default.createElement(Duration_1.default, { durationMillis: millisDuration })))),
                meta.ci && (react_1.default.createElement("tr", null,
                    react_1.default.createElement("th", null, "Build"),
                    react_1.default.createElement("td", null,
                        react_1.default.createElement("a", { href: meta.ci.url }, meta.ci.name)))),
                meta.ci && (react_1.default.createElement("tr", null,
                    react_1.default.createElement("th", null, "Commit"),
                    react_1.default.createElement("td", null,
                        react_1.default.createElement(CICommitLink_1.default, { ci: meta.ci })))),
                meta.implementation && (react_1.default.createElement(Product, { name: "Implementation", product: meta.implementation })),
                meta.runtime && react_1.default.createElement(Product, { name: "Runtime", product: meta.runtime }),
                meta.os && react_1.default.createElement(Product, { name: "OS", product: meta.os }),
                meta.cpu && react_1.default.createElement(Product, { name: "CPU", product: meta.cpu })))));
};
exports.default = ExecutionSummary;
//# sourceMappingURL=ExecutionSummary.js.map