"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var messages_1 = require("@cucumber/messages");
var statusName_1 = __importDefault(require("../gherkin/statusName"));
var StatusIcon_1 = __importDefault(require("../gherkin/StatusIcon"));
var StatusesSummary = function (_a) {
    var scenarioCountByStatus = _a.scenarioCountByStatus;
    var statuses = [
        messages_1.messages.TestStepFinished.TestStepResult.Status.AMBIGUOUS,
        messages_1.messages.TestStepFinished.TestStepResult.Status.FAILED,
        messages_1.messages.TestStepFinished.TestStepResult.Status.PASSED,
        messages_1.messages.TestStepFinished.TestStepResult.Status.PENDING,
        messages_1.messages.TestStepFinished.TestStepResult.Status.SKIPPED,
        messages_1.messages.TestStepFinished.TestStepResult.Status.UNDEFINED,
        messages_1.messages.TestStepFinished.TestStepResult.Status.UNKNOWN,
    ];
    return (react_1.default.createElement("div", { className: "cucumber-status-filter" },
        react_1.default.createElement("table", null,
            react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null,
                    react_1.default.createElement("th", { colSpan: 2 }, "Execution summary"))),
            react_1.default.createElement("tbody", null, statuses.map(function (status, index) {
                var name = statusName_1.default(status);
                var scenarioCount = scenarioCountByStatus.get(status);
                if (scenarioCount === undefined) {
                    return;
                }
                return (react_1.default.createElement("tr", { key: index },
                    react_1.default.createElement("td", null,
                        react_1.default.createElement(StatusIcon_1.default, { status: status }),
                        " ",
                        name),
                    react_1.default.createElement("td", null,
                        scenarioCount,
                        " scenarios")));
            })))));
};
exports.default = StatusesSummary;
//# sourceMappingURL=StatusesSummary.js.map