"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var IdGenerator_1 = __importDefault(require("../../IdGenerator"));
var Description_1 = __importDefault(require("./Description"));
var Scenario_1 = __importDefault(require("./Scenario"));
var Background_1 = __importDefault(require("./Background"));
var RuleTitle_1 = __importDefault(require("./RuleTitle"));
var generator = new IdGenerator_1.default();
var Rule = function (_a) {
    var rule = _a.rule;
    var idGenerated = generator.generate(rule.name);
    return (react_1.default.createElement("section", { className: "cucumber-rule" },
        react_1.default.createElement(RuleTitle_1.default, { id: idGenerated, rule: rule }),
        react_1.default.createElement("div", { className: "cucumber-children" },
            react_1.default.createElement(Description_1.default, { description: rule.description }),
            (rule.children || []).map(function (child, index) {
                if (child.background) {
                    return react_1.default.createElement(Background_1.default, { key: index, background: child.background });
                }
                else if (child.scenario) {
                    return react_1.default.createElement(Scenario_1.default, { key: index, scenario: child.scenario });
                }
                else {
                    throw new Error('Expected background or scenario');
                }
            }))));
};
exports.default = Rule;
//# sourceMappingURL=Rule.js.map