"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var gherkin_utils_1 = require("@cucumber/gherkin-utils");
function filterByStatus(gherkinDocument, gherkinQuery, cucumberQuery, statuses) {
    var filters = {
        acceptScenario: function (scenario) {
            var pickleIds = gherkinQuery.getPickleIds(gherkinDocument.uri, scenario.id);
            return pickleIds
                .map(function (pickleId) {
                return statuses.includes(cucumberQuery.getWorstTestStepResult(cucumberQuery.getPickleTestStepResults([pickleId])).status);
            })
                .includes(true);
        },
    };
    var walker = new gherkin_utils_1.GherkinDocumentWalker(__assign(__assign({}, gherkin_utils_1.rejectAllFilters), filters));
    return walker.walkGherkinDocument(gherkinDocument);
}
exports.default = filterByStatus;
//# sourceMappingURL=filterByStatus.js.map