"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var assert_1 = __importDefault(require("assert"));
var fake_cucumber_1 = require("@cucumber/fake-cucumber");
var gherkin_utils_1 = require("@cucumber/gherkin-utils");
var query_1 = require("@cucumber/query");
var messages_1 = require("@cucumber/messages");
var filterByStatus_1 = __importDefault(require("../../src/filter/filterByStatus"));
var gherkin_utils_2 = require("@cucumber/gherkin-utils");
var runFeature_1 = __importStar(require("../runFeature"));
function scenarioNames(gherkinDocument) {
    if (gherkinDocument === null) {
        return [];
    }
    return gherkinDocument.feature.children
        .filter(function (child) { return child.scenario; })
        .map(function (child) { return child.scenario.name; });
}
describe('filterByStatus', function () {
    var gherkinQuery;
    var cucumberQuery;
    var supportCode;
    var feature = "\nFeature: statuses\n\n  Scenario: passed\n    Given a passed step\n\n  Scenario: failed\n    Given a failed step\n\n  Scenario: undefined\n    Given we have no clue how to handle this step\n    ";
    beforeEach(function () {
        gherkinQuery = new gherkin_utils_1.Query();
        cucumberQuery = new query_1.Query();
        supportCode = new fake_cucumber_1.SupportCode();
        supportCode.defineStepDefinition(null, 'a passed step', function () { return null; });
        supportCode.defineStepDefinition(null, 'a failed step', function () {
            throw new Error('Something bad happened here ...');
        });
    });
    it('only accepts scenarios having one of the expected results', function () { return __awaiter(void 0, void 0, void 0, function () {
        var emitted, gherkinDocument, passedScenarios, failedScenarios, undefinedScenarios;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, runFeature_1.default(feature, gherkinQuery, supportCode)];
                case 1:
                    emitted = _a.sent();
                    gherkinDocument = emitted.find(function (envelope) { return envelope.gherkinDocument; })
                        .gherkinDocument;
                    emitted.map(function (message) { return cucumberQuery.update(message); });
                    passedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.PASSED]);
                    assert_1.default.deepStrictEqual(scenarioNames(passedScenarios), ['passed']);
                    failedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.FAILED]);
                    assert_1.default.deepStrictEqual(scenarioNames(failedScenarios), ['failed']);
                    undefinedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.UNDEFINED]);
                    assert_1.default.deepStrictEqual(scenarioNames(undefinedScenarios), ['undefined']);
                    return [2 /*return*/];
            }
        });
    }); });
    it('can filter with multiple statuses', function () { return __awaiter(void 0, void 0, void 0, function () {
        var emitted, gherkinDocument, passedAndFailedScenarios;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, runFeature_1.default(feature, gherkinQuery, supportCode)];
                case 1:
                    emitted = _a.sent();
                    gherkinDocument = emitted.find(function (envelope) { return envelope.gherkinDocument; })
                        .gherkinDocument;
                    emitted.map(function (message) { return cucumberQuery.update(message); });
                    passedAndFailedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [
                        messages_1.messages.TestStepFinished.TestStepResult.Status.PASSED,
                        messages_1.messages.TestStepFinished.TestStepResult.Status.FAILED,
                    ]);
                    assert_1.default.deepStrictEqual(scenarioNames(passedAndFailedScenarios), [
                        'passed',
                        'failed',
                    ]);
                    return [2 /*return*/];
            }
        });
    }); });
    context('when using examples', function () {
        var featureWithExamples = "Feature: with examples\n\n  Scenario: using examples\n    Given a <status> step\n\n    Examples: some statuses\n      | status |\n      | passed |\n      | failed |\n";
        it('does not keep scenarios when no result matches', function () { return __awaiter(void 0, void 0, void 0, function () {
            var emitted, gherkinDocument, pendingScenarios;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runFeature_1.default(featureWithExamples, gherkinQuery, supportCode)];
                    case 1:
                        emitted = _a.sent();
                        gherkinDocument = emitted.find(function (envelope) { return envelope.gherkinDocument; }).gherkinDocument;
                        emitted.map(function (message) { return cucumberQuery.update(message); });
                        pendingScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.PENDING]);
                        assert_1.default.deepStrictEqual(scenarioNames(pendingScenarios), []);
                        return [2 /*return*/];
                }
            });
        }); });
        it('does not drop the lines of Example tables with the incorrect status', function () { return __awaiter(void 0, void 0, void 0, function () {
            var emitted, gherkinDocument, onlyPassedScenarios;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runFeature_1.default(featureWithExamples, gherkinQuery, supportCode)];
                    case 1:
                        emitted = _a.sent();
                        gherkinDocument = emitted.find(function (envelope) { return envelope.gherkinDocument; }).gherkinDocument;
                        emitted.map(function (message) { return cucumberQuery.update(message); });
                        onlyPassedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.PASSED]);
                        assert_1.default.strictEqual(gherkin_utils_2.pretty(onlyPassedScenarios), featureWithExamples);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    context('when before hook steps fail', function () {
        it('takes those step statuses into account', function () { return __awaiter(void 0, void 0, void 0, function () {
            var emitted, gherkinDocument, onlyFailedScenarios;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        supportCode.registerBeforeHook(new runFeature_1.FailingHook('1234-5678'));
                        return [4 /*yield*/, runFeature_1.default(feature, gherkinQuery, supportCode)];
                    case 1:
                        emitted = _a.sent();
                        gherkinDocument = emitted.find(function (envelope) { return envelope.gherkinDocument; }).gherkinDocument;
                        emitted.map(function (message) { return cucumberQuery.update(message); });
                        onlyFailedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.FAILED]);
                        assert_1.default.deepStrictEqual(scenarioNames(onlyFailedScenarios), [
                            'passed',
                            'failed',
                            'undefined',
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    context('when after hook steps fail', function () {
        it('takes those step statuses into account', function () { return __awaiter(void 0, void 0, void 0, function () {
            var emitted, gherkinDocument, onlyFailedScenarios;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        supportCode.registerAfterHook(new runFeature_1.FailingHook('1234-5678'));
                        return [4 /*yield*/, runFeature_1.default(feature, gherkinQuery, supportCode)];
                    case 1:
                        emitted = _a.sent();
                        gherkinDocument = emitted.find(function (envelope) { return envelope.gherkinDocument; }).gherkinDocument;
                        emitted.map(function (message) { return cucumberQuery.update(message); });
                        onlyFailedScenarios = filterByStatus_1.default(gherkinDocument, gherkinQuery, cucumberQuery, [messages_1.messages.TestStepFinished.TestStepResult.Status.FAILED]);
                        assert_1.default.deepStrictEqual(scenarioNames(onlyFailedScenarios), [
                            'passed',
                            'failed',
                            'undefined',
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=filterByStatusTest.js.map